
%  This code is written to make any colored video grayscale. There is also
%  an option to resize the videos with changing the scalar value of
%  "ImRszFac". Videos appear in webpage, are resized with ImRszFac = 0.5.

clc;
clear;
close all;

%       Parameters Setting

ImRszFac    =   0.5;

%   Reading the video
% obVdeo      =   VideoReader('sara.mp4');
% obVdeo      =   VideoReader('Mouse.mp4');
  obVdeo      =   VideoReader('B.mp4');
% obVdeo      =   VideoReader('D.mp4');
q           =   0;

while hasFrame(obVdeo)
    q       =   q + 1;
    video   =   readFrame(obVdeo);
    video   =   rgb2gray(video);
    video   =   double(video);
    video   =   imresize(video, ImRszFac);
    n_1     =   size(video,1);
    n_2     =   size(video,2);
    X_Vdeo_mat(:,:,q) = reshape(video, [n_1 , n_2, 1]);
    fprintf('Frame # %d has been read...\n', q);
end

GrayVideo_Plane    =   VideoWriter('GrayVid_Bac');

open(GrayVideo_Plane);


for   t    =  1  :   q
    
    writeVideo(GrayVideo_Plane, uint8(abs(X_Vdeo_mat(:,:,t))));
    
end

close(GrayVideo_Plane);



