function [Xhat_tnsr,ERRTWF] = TWF2D(Y, Params)

Masks2       =    getGlobalMasks;
X_Vdeo       =    getGlobalX_Vdeo;
NormX        =    getGlobalNormX;
Xhat_tnsr    =    zeros(Params.n1, Params.n2, Params.q);
ERRitertot   =    zeros(Params.q,Params.T);

for na = 1 : Params.q
    X       =   X_Vdeo(:,:,na);
    A       =   @(I)  fft2(conj(Masks2(:,:,:,na)) .* reshape(repmat(I,[1 Params.L]), size(I,1), size(I,2), Params.L));
    At      =   @(W) sum(Masks2(:,:,:,na) .* ifft2(W), 3) * size(W,1) * size(W,2);
    [Xhat,ERRiter]     =   TWF(Y(:,:,:,na), Params, A, At, X);
    ERRitertot(na,:)   =   ERRiter;
    Xhat_tnsr(:,:,na)  =   Xhat;
    
end
RR            =    sum(ERRitertot);
ERRTWF(:)     =    RR/NormX;